package cn.com.qmth.examcloud.core.basic.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.data.repository.query.QueryByExampleExecutor;
import org.springframework.transaction.annotation.Transactional;

import cn.com.qmth.examcloud.core.basic.dao.entity.UserEntity;

/**
 * Created by songyue on 17/1/13.
 */
public interface UserRepo
		extends
			JpaRepository<UserEntity, Long>,
			QueryByExampleExecutor<UserEntity>,
			JpaSpecificationExecutor<UserEntity> {

	UserEntity findByRootOrgIdAndLoginName(long rootOrgId, String loginName);

	List<UserEntity> findByLoginName(String loginName);

	@Transactional
	@Modifying
	@Query("update UserEntity set password = :password where id = :id")
	void updatePasswordById(@Param("id") long id, @Param("password") String password);

	int countByLoginName(String loginName);

	List<UserEntity> findByOrgId(Long orgId);

	List<UserEntity> findByRootOrgId(Long rootOrgId);

	int countByRootOrgId(Long rootOrgId);

}
